//+------------------------------------------------------------------+
//|  Mladen 23 October 2010                                          |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Yellow
#property indicator_color2 Yellow
#property indicator_color3 Red
#property indicator_color4 Red 
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 2
#property indicator_width4 2
//
//
//
//
//

extern string TimeFrame   = "current time frame";
extern int    MaPeriod    = 34;
extern int    MaShift     = 0;
extern int    MaMethod    = MODE_EMA;//***************
extern int    UpperPrice  = PRICE_HIGH;
extern int    LowerPrice  = PRICE_LOW;
extern double Deviation   = 0.2;//0.2 and I wonder why?
extern bool   Interpolate = true;

//
//
//
//
//

double UpLine[];
double DnLine[]; 
double UpArrow[];
double DnArrow[]; 
double smax[];
double smin[];
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,UpLine);  
      SetIndexBuffer(1,DnLine);  
      SetIndexBuffer(2,UpArrow); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,147);
      SetIndexBuffer(3,DnArrow); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,147);
      SetIndexBuffer(5,smin);
      SetIndexBuffer(6,smax);
      SetIndexBuffer(7,trend);
   
      //
      //
      // 
      //
      //
   
         MaPeriod          = MathMax(MaPeriod,2);
         Deviation         = MathMax(MathMin(Deviation,100),0.0);
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
 
         for (int i=0;i<4;i++) SetIndexShift(i,MaShift*timeFrame/Period());
   IndicatorShortName(timeFrameToString(timeFrame)+" trend envelopes("+MaPeriod+")");
   return(0);
}
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { UpLine[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
      for(i=limit; i>=0; i--)
      { 
         smax[i]    = (1+Deviation/100)*iMA(NULL,0,MaPeriod,0,MaMethod,UpperPrice,i);
         smin[i]    = (1-Deviation/100)*iMA(NULL,0,MaPeriod,0,MaMethod,LowerPrice,i);
         UpLine[i]  = EMPTY_VALUE;
         DnLine[i]  = EMPTY_VALUE;
         UpArrow[i] = EMPTY_VALUE;
         DnArrow[i] = EMPTY_VALUE;
         trend[i]   = trend[i+1]; 
   
         //
         //
         //
         //
         //
         
	      if (Close[i]>smax[i+1]) trend[i]= 1; 
	      if (Close[i]<smin[i+1]) trend[i]=-1;
	      if (trend[i]>0 && smin[i]<smin[i+1]) smin[i]=smin[i+1];
	      if (trend[i]<0 && smax[i]>smax[i+1]) smax[i]=smax[i+1];
         if (trend[i] == 1)
            {  
               UpLine[i] = smin[i]; if (trend[i+1]!= 1) UpArrow[i] = UpLine[i];
            }
         if (trend[i] ==-1)
            {  
               DnLine[i] = smax[i]; if (trend[i+1]!=-1) DnArrow[i] = DnLine[i];
            }
      }
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         UpLine[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaShift,MaMethod,UpperPrice,LowerPrice,Deviation,0,y);
         DnLine[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaShift,MaMethod,UpperPrice,LowerPrice,Deviation,1,y);
         UpArrow[i] = EMPTY_VALUE;
         DnArrow[i] = EMPTY_VALUE;
            if (UpLine[i]!= EMPTY_VALUE && UpLine[i+1]==EMPTY_VALUE) UpArrow[i]=UpLine[i];
            if (DnLine[i]!= EMPTY_VALUE && DnLine[i+1]==EMPTY_VALUE) DnArrow[i]=DnLine[i];
               
         //
         //
         //
         //
         //
                        
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
            for(int k = 1; k < n; k++)
            {
               if (UpLine[i]!=EMPTY_VALUE && UpLine[i+n]!=EMPTY_VALUE) UpLine[i+k] = UpLine[i] + (UpLine[i+n]-UpLine[i])*k/n;
               if (DnLine[i]!=EMPTY_VALUE && DnLine[i+n]!=EMPTY_VALUE) DnLine[i+k] = DnLine[i] + (DnLine[i+n]-DnLine[i])*k/n;
            }
   }
   return(0);         
}


//+-----------------------------------------------------------------------------------------------------------------------------+
//|                                                                                                                             |
//+-----------------------------------------------------------------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//===================================================================+